﻿-- Author      : Administrator
-- Create Date : 10/18/2014 2:49:39 PM


local backdrop_move ={ bgFile = "",
						edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
						tile = true, tileSize = 8, edgeSize = 8, 
						insets = { left = 2, right = 2, top = 2, bottom = 2 }};

local function Frame_OnMouseDown(frame)
	frame:StartMoving()
end

local function Frame_OnMouseUp(frame)
	frame:StopMovingOrSizing();
	frame.obj:SaveLocation();
end

local methods = {
	["RefreshSize"] = function(self)
		local width = 0;
		local height = 0;
		
		self.framemain:ClearAllPoints();		
		if Default_Settings.modelparty then
			height = Default_Settings.selfsize.height * 8 + Default_Settings.selfsize.linespace * 7;
			width = Default_Settings.selfsize.width * 5 + Default_Settings.selfsize.columnspace * 4;
		else
			height = Default_Settings.selfsize.height * 5 + Default_Settings.selfsize.linespace * 4;
			width = Default_Settings.selfsize.width * 8 + Default_Settings.selfsize.columnspace * 7;
		end
		
		self.framemain:SetSize(width,height)
		if Default_Settings.modelinvert then
			if Default_Settings.modelparty then
				self.framemain:SetPoint("BOTTOMLEFT", "UIParent","BOTTOMLEFT",Default_Settings.selflocation[1], Default_Settings.selflocation[2]);
			else
				self.framemain:SetPoint("TOPRIGHT", "UIParent","BOTTOMLEFT",Default_Settings.selflocation[1], Default_Settings.selflocation[2]);
			end
		else
			self.framemain:SetPoint("TOPLEFT", "UIParent","BOTTOMLEFT",Default_Settings.selflocation[1], Default_Settings.selflocation[2]);
		end
		------------------------bar----
		local i = 1;
		local x = 0;
		local y = 0;
		while i <= 40 do
			local _tempbar = self.barlist[i];
			local _tempbara = self.barlistattach[i];
			_tempbar:ClearAllPoints();
			_tempbara:ClearAllPoints();	
			if Default_Settings.modelinvert then
				if Default_Settings.modelparty then
					x = i % 5;
					if x == 0 then
						x = 5;
					end
					x = x - 1;
					x = x * (Default_Settings.selfsize.width+Default_Settings.selfsize.columnspace);
					y = 7 - math.ceil(i / 5) + 1;
					y = y * (Default_Settings.selfsize.height+Default_Settings.selfsize.linespace);
				else
					x = 7 - math.ceil(i / 5) + 1;
					x = x * (Default_Settings.selfsize.width+Default_Settings.selfsize.columnspace);
					y = i % 5;
					if y == 0 then
						y = 5;
					end
					y = y - 1;
					y = y * (Default_Settings.selfsize.height+Default_Settings.selfsize.linespace);
				end
			else
				if Default_Settings.modelparty then
					x = i % 5;
					if x == 0 then
						x = 5;
					end
					x = x - 1;					
					x = x * (Default_Settings.selfsize.width+Default_Settings.selfsize.columnspace);
					y = math.ceil(i / 5) - 1;
					y = y * (Default_Settings.selfsize.height+Default_Settings.selfsize.linespace);
				else
					x = math.ceil(i / 5) - 1;
					x = x * (Default_Settings.selfsize.width+Default_Settings.selfsize.columnspace);
					y = i % 5;
					if y == 0 then
						y = 5;
					end
					y = y - 1;					
					y = y * (Default_Settings.selfsize.height+Default_Settings.selfsize.linespace);
				end
			end
			_tempbar:SetTexture(Default_Settings.color.all[1], Default_Settings.color.all[2],Default_Settings.color.all[3],Default_Settings.color.alpha);		
			_tempbar:SetWidth(Default_Settings.selfsize.width)
			_tempbar:SetHeight(Default_Settings.selfsize.height)
			_tempbar:SetPoint("TOPLEFT",self.framemain,"TOPLEFT",x,-y);
			
			
			_tempbara:SetTexture(Default_Settings.color.magic[1], Default_Settings.color.magic[2],Default_Settings.color.magic[3],Default_Settings.color.alpha);
			_tempbara:SetHeight(Default_Settings.selfsize.height)
			_tempbara:SetPoint("LEFT",_tempbar,"RIGHT",-1,0);	
			
			i = i + 1;
		end
		--DEFAULT_CHAT_FRAME:AddMessage("RefreshSize end");
	end,
	["RefreshColor"] = function(self)
		local i = 1;
		while i <= 40 do
			self.barlist[i]:SetTexture(Default_Settings.color.all[1], Default_Settings.color.all[2],Default_Settings.color.all[3],Default_Settings.color.alpha);
			i = i + 1;
		end
	end,
	["SaveLocation"] = function(self)
		if Default_Settings.modelinvert then
			if Default_Settings.modelparty  then
				Default_Settings.selflocation[1] = self.framemain:GetLeft();
				Default_Settings.selflocation[2] = self.framemain:GetBottom();
			else
				Default_Settings.selflocation[1] = self.framemain:GetRight();
				Default_Settings.selflocation[2] = self.framemain:GetTop();
			end
		else			
			Default_Settings.selflocation[1] = self.framemain:GetLeft();
			Default_Settings.selflocation[2] = self.framemain:GetTop();
		end
	end,
	["BarVisible"] = function(self,value)		
		if value then
			local i = 1;
			while i <= 40 do
				self.barlist[i]:SetWidth(Default_Settings.selfsize.width);
				self.barlist[i]:Show();
				self.barlistattach[i]:Hide();
				i = i + 1;
			end
		else
			local i = 1;
			while i <= 40 do
				self.barlist[i]:SetWidth(1);
				self.barlist[i]:Hide();
				self.barlistattach[i]:Hide();
				i = i + 1;
			end
		end
		--DEFAULT_CHAT_FRAME:AddMessage("BarVisible end");
	end,
	["LockFrame"] = function(self,value)
		if value then
			self.framemain:SetMovable(false);
			self.framemain:EnableMouse(false);
			self.framemain:SetBackdrop(nil);
			self:BarVisible(false);
		else
			self.framemain:SetMovable(true);
			self.framemain:EnableMouse(true);
			self.framemain:SetBackdrop(backdrop_move);
			self:BarVisible(true);
		end
	end,
	["Cernter"] = function(self)
		self.framemain:ClearAllPoints();
		if Default_Settings.modelinvert then
			if Default_Settings.modelparty then
				self.framemain:SetPoint("BOTTOMLEFT", "UIParent","CENTER");
			else
				self.framemain:SetPoint("TOPRIGHT", "UIParent","CENTER");
			end
		else
			self.framemain:SetPoint("TOPLEFT", "UIParent","CENTER");
		end
	end,
	["PrintValue"] =  function(self,id,all,physical,magic)
		if all > 1 then
			all = 1;
		end
		if (magic + all) > 1 then
			magic = 1 - all;
		end
		if (physical + all) > 1 then
			physical = 1 - all;
		end
		
		if all == 0 then
			if self.barlist[id]:IsShown() then
				self.barlist[id]:Hide();
			end
		else
			local val_all = all * Default_Settings.selfsize.width;
			self.barlist[id]:SetWidth(val_all);
			if self.barlist[id]:IsShown() then
			else
				self.barlist[id]:Show();
			end
		end
		
		if magic > 0 or physical > 0 then
			local val_all = (magic + physical) * Default_Settings.selfsize.width;
			self.barlistattach[id]:SetWidth(val_all);
			if self.barlistattach[id]:IsShown() then
			else
				self.barlistattach[id]:Show();
			end
			if magic > 0 then
				self.barlistattach[id]:SetTexture(Default_Settings.color.magic[1], Default_Settings.color.magic[2],Default_Settings.color.magic[3],Default_Settings.color.alpha);
			else
				self.barlistattach[id]:SetTexture(Default_Settings.color.physical[1], Default_Settings.color.physical[2],Default_Settings.color.physical[3],Default_Settings.color.alpha);
			end
		else
			if self.barlistattach[id]:IsShown() then
				self.barlistattach[id]:Hide();
			end
		end
	end
}


function ConstructorMainFrame()
	local framemain = CreateFrame("Frame","mainFrame",UIParent)
	local barlist = {};
	local barlistattach = {};
	do
		local i = 1;
		while i <= 40 do
			local _tempbar = CreateFrame("Frame",nil,framemain)		
			_tempbar:SetFrameStrata("HIGH")
			_tempbar:SetWidth(Default_Settings.selfsize.width) 
			_tempbar:SetHeight(Default_Settings.selfsize.height)
			local _temp = _tempbar:CreateTexture(nil,"BACKGROUND");
			_temp:SetAllPoints(_tempbar);
			_tempbar.texture = _temp;
			
			local _tempbara = CreateFrame("Frame",nil,framemain)		
			_tempbara:SetFrameStrata("HIGH")
			_tempbara:SetWidth(Default_Settings.selfsize.width) 
			_tempbara:SetHeight(Default_Settings.selfsize.height)
			local _tempa = _tempbara:CreateTexture(nil,"BACKGROUND");
			_tempa:SetAllPoints(_tempbara);
			_tempbara.texture = _tempa;
			
			barlist[i] = _temp;
			barlistattach[i] = _tempa;
			i = i + 1;
		end
	end
	framemain:SetWidth(16)
	framemain:SetHeight(16)
	framemain:SetMovable(false);
	framemain:EnableMouse(false);
	framemain:SetToplevel(1);
	framemain:SetScript("OnMouseUp",Frame_OnMouseUp);
	framemain:SetScript("OnMouseDown",Frame_OnMouseDown);
	framemain:Hide();
	local widget = {
		framemain = framemain,
		barlist = barlist,
		barlistattach = barlistattach
	}
	for method, func in pairs(methods) do
		widget[method] = func
	end
	framemain.obj = widget
	return widget
end