﻿-- Author      : Administrator
-- Create Date : 10/18/2014 2:07:37 PM

local K = KeepSpell
local L10N = iShieldDB_Translations
local backdrop_move ={ bgFile = "",
						edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
						tile = true, tileSize = 4, edgeSize = 4, 
						insets = { left = 4, right = 4, top = 4, bottom = 4 }};

local colorFrameBackdrop ={ bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
						edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
						tile = true, tileSize = 2, edgeSize = 2, 
						insets = { left = 2, right = 2, top = 2, bottom = 2 }};

local sliderBackdrop  = {bgFile = "Interface\\Buttons\\UI-SliderBar-Background",
						edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
						tile = true, tileSize = 8, edgeSize = 8,
						insets = { left = 3, right = 3, top = 6, bottom = 6 }};
						
local ManualBackdrop = {
	bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
	edgeFile = "Interface\\ChatFrame\\ChatFrameBackground",
	tile = true, edgeSize = 1, tileSize = 5,}
		
local function ScrollFrame_OnMouseWheel(frame, value)
	frame.obj:MoveScroll(value)
end

local function ScrollBar_OnScrollValueChanged(frame, value)
	frame.obj:SetScroll(value)
end

local function CheckButtonModel_OnClick(frame)
	if frame:GetChecked() then
		Default_Settings[frame.obj] = true;
	else
		Default_Settings[frame.obj] = false;
	end
	ModelChange();
end

local function ColorExit_OnClick(frame)
	frame.obj.colorframe:Hide();	
end

local function BarAlpha_OnScrollValueChanged(self,val)	
	local nowVal = math.ceil(val * 100)/100;
	if nowVal ~= Default_Settings.color.alpha then
		Default_Settings.color.alpha = nowVal;
		FrameColorChange();
	end
end

local function EditBox_OnEnter(frame)
	frame:SetBackdropBorderColor(0.5, 0.5, 0.5, 1)
end

local function EditBox_OnLeave(frame)
	frame:SetBackdropBorderColor(0.3, 0.3, 0.3, 0.8)
end

local function EditBox_OnEscapePressed(frame)
	frame:ClearFocus()
end

local function EditBox_OnEnterPressed(frame)
	local self = frame.obj
	local value = frame:GetText()
	if string.len(value) > 0 then
		value = tonumber(value)
		if value == nil then		
			value = 0;
		end
		Default_Settings.shieldmax = value;
		if Default_Settings.shieldmax == 0 then
			self.shieldtxt:SetText(L10N.OptMaxShiel.."Auto");
		else
			self.shieldtxt:SetText(L10N.OptMaxShiel..tostring(Default_Settings.shieldmax));
		end
		frame:SetText("");
		--DEFAULT_CHAT_FRAME:AddMessage("EditBox_OnEnterPressed "..tostring(value)); 
	end
end



local function Color_OnScrollValueChanged(self)
	local nowValR,nowValG,nowValB = self:GetColorRGB();
	nowValR = math.ceil(nowValR * 100)/100;
	nowValG = math.ceil(nowValG * 100)/100;
	nowValB = math.ceil(nowValB * 100)/100;	
	Default_Settings.color[self.obj.colorselectval][1] = nowValR;
	Default_Settings.color[self.obj.colorselectval][2] = nowValG;
	Default_Settings.color[self.obj.colorselectval][3] = nowValB;
	self.obj.colorframe:Hide();
	self.obj.color[self.obj.colorselectval].texture:SetTexture(nowValR,nowValG,nowValB,1)
	FrameColorChange();
	--DEFAULT_CHAT_FRAME:AddMessage(tostring(nowValR).." "..tostring(nowValG).." "..tostring(nowValB))	
end

local function Frame_OnShow()
	OptionsIsShow()
end

local function ButtonRestore_OnClick(frame)
	FrameRestore();
end

local function ButtonColorAll_OnClick(frame)
	frame.obj.colorselectval = "all";
	frame.obj.colorframe:Show();
end
local function ButtonColorMagic_OnClick(frame)
	frame.obj.colorselectval = "magic";
	frame.obj.colorframe:Show();
end
local function ButtonColorPhysical_OnClick(frame)
	frame.obj.colorselectval = "physical";
	frame.obj.colorframe:Show();
end


local function CheckButtonSpell_OnClick(frame)
	if frame:GetChecked() then
		if Default_Settings.unkeepspell[frame.obj] == true then
			Default_Settings.unkeepspell[frame.obj] = nil;
		end		
	else
		Default_Settings.unkeepspell[frame.obj] = true;
	end	
end




local methods = {
	["LoaderUserData"] = function(self)
		self.cbmodelnown:SetChecked(Default_Settings.modelown);
		self.cbmodelparty:SetChecked(Default_Settings.modelparty);
		self.cbmodelblank:SetChecked(Default_Settings.modelblank);
		self.cbmodelinvert:SetChecked(Default_Settings.modelinvert);
		if Default_Settings.shieldmax == 0 then
			self.shieldtxt:SetText(L10N.OptMaxShiel.."Auto");
		else
			self.shieldtxt:SetText(L10N.OptMaxShiel..tostring(Default_Settings.shieldmax));
		end
		--self.shieldmax:SetText(Default_Settings.shieldmax);	
		self.color["all"].texture:SetTexture(Default_Settings.color["all"][1],Default_Settings.color["all"][2],Default_Settings.color["all"][3],1);
		self.color["magic"].texture:SetTexture(Default_Settings.color["magic"][1],Default_Settings.color["magic"][2],Default_Settings.color["magic"][3],1);
		self.color["physical"].texture:SetTexture(Default_Settings.color["physical"][1],Default_Settings.color["physical"][2],Default_Settings.color["physical"][3],1);
		self.coloralpha:SetValue(Default_Settings.color.alpha);
		
		for key, value in pairs(Default_Settings.unkeepspell) do
			if self.spelllist[key] then
				self.spelllist[key]:SetChecked(false);
			end
		end
	end,
	["MoveScroll"] = function(self, value)
		local status = self.status or self.localstatus
		local height, viewheight = self.scrollframe:GetHeight(), self.content:GetHeight()		
		--if self.scrollBarShown then
			local diff = height - viewheight
			local delta = 1
			if value < 0 then
				delta = -1
			end
			local temp  = min(max(status.scrollvalue + delta*(1000/(diff/45)),0), 1000)
			self.scrollbar:SetValue(temp)
		--end
	end,
	["SetScroll"] = function(self, value)
		local status = self.status or self.localstatus
		local viewheight = self.scrollframe:GetHeight()
		local height = self.content:GetHeight()
		local offset

		if viewheight > height then
			offset = 0
		else
			offset = floor((height - viewheight) / 1000.0 * value)
		end
		self.content:ClearAllPoints()
		self.content:SetPoint("TOPLEFT", 0, offset)
		self.content:SetPoint("TOPRIGHT", 0, offset)
		status.offset = offset
		status.scrollvalue = value
	end
}

function ConstructorOptions()
	local self = {}
	local framemain = CreateFrame("Frame","ConfigFrame", InterfaceOptionsFramePanelContainer)
	framemain.name = "iShield"
	framemain:SetScript("OnShow", Frame_OnShow);
	framemain:Hide()
	
	
	local labelTitle =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	labelTitle:SetPoint("TOP", 0, -30)
	labelTitle:SetJustifyH("LEFT")
	labelTitle:SetJustifyV("TOP")
	labelTitle:SetText("|cffff0000iShield|r");
	labelTitle:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE, MONOCHROME")
	
	
	local addoninfo =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	addoninfo:SetPoint("TOPLEFT", 50, -70)
	addoninfo:SetJustifyH("LEFT")
	addoninfo:SetJustifyV("TOP")
	addoninfo:SetText(L10N.OptAddOnInfo);
	
	
	local shieldtxt =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	shieldtxt:SetPoint("TOPLEFT", 50, -150)
	shieldtxt:SetJustifyH("LEFT")
	shieldtxt:SetJustifyV("TOP")	
	shieldtxt:SetText(L10N.OptMaxShiel.."Auto");
	local shieldinfo =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	shieldinfo:SetPoint("TOPLEFT", 150, -170)
	shieldinfo:SetJustifyH("LEFT")
	shieldinfo:SetJustifyV("TOP")
	shieldinfo:SetText(L10N.OptMaxShielInfo);	
	local shieldmax = CreateFrame("EditBox",nil,framemain)
	--shieldmax:SetAutoFocus(true)
	--shieldmax:SetFontObject(GameFontHighlightSmall)
	shieldmax:SetFont("Fonts\\FRIZQT__.TTF", 13, "OUTLINE, MONOCHROME")
	shieldmax:SetPoint("TOPLEFT", 50, -170)
	shieldmax:SetHeight(20)
	shieldmax:SetWidth(90)
	shieldmax:SetJustifyH("LEFT")
	shieldmax:EnableMouse(true)
	shieldmax:SetBackdrop(ManualBackdrop)
	shieldmax:SetBackdropColor(0, 0, 0, 0.5)
	shieldmax:SetBackdropBorderColor(0.3, 0.3, 0.30, 0.80)
	shieldmax:SetScript("OnEnter", EditBox_OnEnter)
	shieldmax:SetScript("OnLeave", EditBox_OnLeave)
	shieldmax:SetScript("OnEnterPressed", EditBox_OnEnterPressed)
	shieldmax:SetScript("OnEscapePressed", EditBox_OnEscapePressed)
	shieldmax:SetMaxBytes(9)
	--shieldmax:SetText(123)	
	
	------------------------list---------------------------
	local buffframe = CreateFrame("Frame", nil, framemain)
	buffframe:SetPoint("TOPLEFT",300,-200)
	buffframe:SetHeight(320)
	buffframe:SetWidth(240)
	buffframe:SetBackdrop(backdrop_move);	
	
	local scrollframe = CreateFrame("ScrollFrame", nil, buffframe)	
	scrollframe:SetPoint("TOPLEFT")
	scrollframe:SetPoint("BOTTOMRIGHT")
	scrollframe:EnableMouseWheel(true)	
	scrollframe:SetScript("OnMouseWheel", ScrollFrame_OnMouseWheel)
	--scrollframe:SetScript("OnSizeChanged", ScrollFrame_OnSizeChanged)
	
	
	local scrollbar = CreateFrame("Slider", nil, scrollframe, "UIPanelScrollBarTemplate")
	scrollbar:SetPoint("TOPLEFT", scrollframe, "TOPRIGHT",  4, -16)
	scrollbar:SetPoint("BOTTOMLEFT", scrollframe, "BOTTOMRIGHT", 4, 16)
	scrollbar:SetMinMaxValues(0, 1000)
	scrollbar:SetValueStep(1)
	scrollbar:SetValue(0)
	scrollbar:SetWidth(16)
	--scrollbar:Hide()

	scrollbar:SetScript("OnValueChanged", ScrollBar_OnScrollValueChanged)
	
	local scrollbg = scrollbar:CreateTexture(nil, "BACKGROUND")
	scrollbg:SetAllPoints(scrollbar)
	scrollbg:SetTexture(0, 0, 0, 0.4)
	
	local content = CreateFrame("Frame", nil, scrollframe)
	content:SetPoint("TOPLEFT")
	content:SetPoint("TOPRIGHT")
	scrollframe:SetScrollChild(content)	
	
	local spelllist = {};
	local spellcount = 0;	
	for k,v  in pairs(K.SpellInfo) do
			spelllist[k] = CreateFrame("CheckButton",nil, content, "UICheckButtonTemplate")
			spelllist[k]:SetPoint("TOPLEFT", 30, -20 - (spellcount * 30))
			spelllist[k].type = "checkbox"
			spelllist[k].text:SetText(GetSpellInfo(k))
			spelllist[k]:SetChecked(true)
			spelllist[k].obj = k;			
			spelllist[k]:SetScript("OnClick", CheckButtonSpell_OnClick)	
			spellcount = spellcount + 1;	
	end
	content:SetHeight(spellcount * 30 + 20)
	
	-----------------------------rests------------------------------
	local cbmodelnown = CreateFrame("CheckButton",nil, framemain, "UICheckButtonTemplate")
	cbmodelnown:SetPoint("TOPLEFT", 50, -200)
	cbmodelnown.type = "checkbox"
	cbmodelnown.text:SetText(L10N.OptModeOwn)
	cbmodelnown.obj = "modelown";
	cbmodelnown:SetScript("OnClick", CheckButtonModel_OnClick)
	
	local cbmodelparty = CreateFrame("CheckButton",nil, framemain, "UICheckButtonTemplate")
	cbmodelparty:SetPoint("TOPLEFT", 50, -230)
	cbmodelparty.type = "checkbox"
	cbmodelparty.text:SetText(L10N.OptModeParty)
	cbmodelparty.obj = "modelparty";
	cbmodelparty:SetScript("OnClick", CheckButtonModel_OnClick)
	
	local cbmodelblank = CreateFrame("CheckButton",nil, framemain, "UICheckButtonTemplate")
	cbmodelblank:SetPoint("TOPLEFT", 50, -260)
	cbmodelblank.type = "checkbox"
	cbmodelblank.text:SetText(L10N.OptModeBlanks)
	cbmodelblank.obj = "modelblank";
	cbmodelblank:SetScript("OnClick", CheckButtonModel_OnClick)	
	
	local cbmodelinvert = CreateFrame("CheckButton",nil, framemain, "UICheckButtonTemplate")
	cbmodelinvert:SetPoint("TOPLEFT", 50, -290)
	cbmodelinvert.type = "checkbox"
	cbmodelinvert.text:SetText(L10N.OptModeInverted)
	cbmodelinvert.obj = "modelinvert";
	cbmodelinvert:SetScript("OnClick", CheckButtonModel_OnClick)	
	
	
	---------------------------color---------------------------------
	local colorframe = CreateFrame("Frame",nil,framemain)
	colorframe:SetWidth(150)
	colorframe:SetHeight(180)
	colorframe:SetToplevel(1);
	colorframe:SetBackdrop(colorFrameBackdrop);
	colorframe:SetPoint("CENTER","UIParent","CENTER");
	local colorselect = CreateFrame("ColorSelect", nil, colorframe)
	colorselect.mytype = "colorselect";
	colorselect:SetWidth(128)
	colorselect:SetHeight(128)
	colorselect:SetPoint("TOP")
	local colorwheel = colorselect:CreateTexture()
	colorwheel:SetWidth(128)
	colorwheel:SetHeight(128)
	colorwheel:SetPoint("TOP", colorselect, "TOP",0,-5)
	colorselect:SetColorWheelTexture(colorwheel)
	local colorwheelthumbtexture = colorselect:CreateTexture()
	colorwheelthumbtexture:SetTexture("Interface\\Buttons\\UI-ColorPicker-Buttons")
	colorwheelthumbtexture:SetWidth(10)
	colorwheelthumbtexture:SetHeight(10)
	colorwheelthumbtexture:SetTexCoord(0,0.15625, 0, 0.625)
	colorselect:SetColorWheelThumbTexture(colorwheelthumbtexture)
	colorselect:SetScript("OnColorSelect", Color_OnScrollValueChanged)
	colorframe:Hide();
	local colorexit = CreateFrame("Button", nil, colorframe, "UIPanelButtonTemplate");
	colorexit:SetScript("OnClick", ColorExit_OnClick);
	colorexit:SetPoint("BOTTOM", 0, 10)
	colorexit:SetHeight(20);
	colorexit:SetWidth(40);
	colorexit:SetText("Exit");
	
	local colorall = CreateFrame("Frame",nil,framemain);
	colorall:SetWidth(30) -- Set these to whatever height/width is needed 
	colorall:SetHeight(20) -- for your Texture
	local colorallf = colorall:CreateTexture(nil,"BACKGROUND")
	colorallf:SetTexture(1,0.5,0.3,1)
	colorallf:SetAllPoints(colorall)
	colorall.texture = colorallf
	colorall:SetScript("OnMouseDown",ButtonColorAll_OnClick);
	colorall:SetPoint("TOPLEFT", 50, -330)	
	local coloralltext =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	coloralltext:SetPoint("TOPLEFT", 90, -330)
	coloralltext:SetJustifyH("LEFT")
	coloralltext:SetJustifyV("TOP")
	coloralltext:SetText(L10N.OptColorAll);
	
	local colormagic = CreateFrame("Frame",nil,framemain);
	colormagic:SetWidth(30)
	colormagic:SetHeight(20)
	local colormagicf = colormagic:CreateTexture(nil,"BACKGROUND")
	colormagicf:SetTexture(0,0,1,1)
	colormagicf:SetAllPoints(colormagic)
	colormagic.texture = colormagicf
	colormagic:SetScript("OnMouseDown",ButtonColorMagic_OnClick);
	colormagic:SetPoint("TOPLEFT", 50, -370)	
	local colormagictext =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	colormagictext:SetPoint("TOPLEFT", 90, -370)
	colormagictext:SetJustifyH("LEFT")
	colormagictext:SetJustifyV("TOP")
	colormagictext:SetText(L10N.OptColorMagic);
	
	
	local colorphysical = CreateFrame("Frame",nil,framemain);
	colorphysical:SetWidth(30)
	colorphysical:SetHeight(20)
	local colorphysicalf = colorall:CreateTexture(nil,"BACKGROUND")
	colorphysicalf:SetTexture(1,0,0,1)
	colorphysicalf:SetAllPoints(colorphysical)
	colorphysical.texture = colorphysicalf
	colorphysical:SetScript("OnMouseDown",ButtonColorPhysical_OnClick);
	colorphysical:SetPoint("TOPLEFT", 50, -410)	
	local colorphysicaltext =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	colorphysicaltext:SetPoint("TOPLEFT", 90, -410)
	colorphysicaltext:SetJustifyH("LEFT")
	colorphysicaltext:SetJustifyV("TOP")
	colorphysicaltext:SetText(L10N.OptColorPhysical);
	
	
	local coloralphatext =framemain:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	coloralphatext:SetPoint("TOPLEFT", 50, -450)
	coloralphatext:SetJustifyH("LEFT")
	coloralphatext:SetJustifyV("TOP")
	coloralphatext:SetText(L10N.OptColorAlpha);	
	
	local coloralpha= CreateFrame("Slider", nil, framemain)
	coloralpha:SetOrientation("HORIZONTAL")
	coloralpha:SetWidth(150)
	coloralpha:SetHeight(14)
	coloralpha:SetHitRectInsets(0, 0, -10, 0)
	coloralpha:SetBackdrop(sliderBackdrop)
	coloralpha:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
	coloralpha:SetPoint("TOPLEFT", 50, -470)
	coloralpha:SetMinMaxValues(0, 1.0)
	coloralpha:SetValueStep(0.01)
	coloralpha:SetValue(0.6)
	coloralpha:SetScript("OnValueChanged", BarAlpha_OnScrollValueChanged)
	
	local color = {};
	color.all = colorall;
	color.magic = colormagic;
	color.physical = colorphysical;
	
	------------
	local buttonrestore = CreateFrame("Button", nil, framemain, "UIPanelButtonTemplate");
	buttonrestore:SetScript("OnClick", ButtonRestore_OnClick);
	buttonrestore:SetPoint("TOPLEFT", 50, -500)
	buttonrestore:SetHeight(30);
	buttonrestore:SetWidth(100);
	buttonrestore:SetText(L10N.OptRestoreFrame);

	local widget = {
		localstatus = { scrollvalue = 0 },
		scrollframe = scrollframe,
		scrollbar   = scrollbar,
		content     = content,
		buffframe   = buffframe,
		framemain	= framemain,
		spelllist	= spelllist,
		shieldmax	= shieldmax,
		shieldtxt	= shieldtxt,
		cbmodelnown = cbmodelnown,
		cbmodelparty = cbmodelparty,
		cbmodelblank = cbmodelblank,
		cbmodelinvert = cbmodelinvert,
		colorframe = colorframe,
		colorselectval = "all",
		coloralpha = coloralpha,
		color = color
	}
	for method, func in pairs(methods) do
		widget[method] = func
	end
	scrollframe.obj, scrollbar.obj = widget, widget
	shieldmax.obj = widget
	colorselect.obj,colorall.obj,colormagic.obj ,colorphysical.obj,colorexit.obj = widget,widget,widget,widget,widget
	
	InterfaceOptions_AddCategory(framemain)
	scrollbar.obj:SetScroll(1)
	return widget
end